clear all
close all

%ROIs = false;
ROIs = true;

pixel2nm = 104;
x_size = 3000;
y_size = 3000;
pixel_size = 104 / 20;

infile1 = ...
   'NewSample_Cell2_Label1_secondtry#0001-2016-4-19-16-11-13_Results.mat';
infile2 = 'Cell2_secondtry_label2#0001-2016-4-20-1-7-11_Results.mat';

results = 'results';
basefile = 'Cell2';
base = sprintf('%s/%s', results, basefile);

E = 30;
minPts = 3;
options = 'O';
shrinkFactor = 0.5;

c = Clustering();
c.Plotting = false;

pc = PairCorr();
pc.Fig_ext = '';
pc.Lines = true;
pc.Results = results;
pc.Rmax_axis = 500;

SRc = SRcluster();
SRc.ShrinkFactor = shrinkFactor;
SRc.PlotFigures = false;
%SRc.Algorithm = 'DBSCAN_Daszykowski';   SRc.minPts = minPts;   SRc.E = E;

if ROIs
   [n_ROIs, RoI, Sigma_Reg] = c.getROI(infile1, x_size, y_size, infile2);
   saveas(gcf, sprintf('%s_ROIs.fig', base));
   print(sprintf('%s_ROIs.png', base), '-dpng');
   close all
else
   n_ROIs = 1;

   load(infile1);
%  Sigma_Reg = std(SRD.DriftCorrect_XYShift) .* pixel2nm;  %nm
%  if exist('Sigma_Reg', 'var') && isnan(Sigma_Reg)
      Sigma_Reg = [10, 10];
%  end

   RoI{1}.X1 = double(SRD.Results.X) .* pixel2nm;   % nm
   RoI{1}.Y1 = double(SRD.Results.Y) .* pixel2nm;   % nm
   RoI{1}.X1_STD = double(SRD.Results.X_STD) .* pixel2nm;   % nm
   RoI{1}.Y1_STD = double(SRD.Results.Y_STD) .* pixel2nm;   % nm

   load(infile2);
%  Sigma_Reg = std(SRD.DriftCorrect_XYShift) .* pixel2nm;  %nm
%  if exist('Sigma_Reg', 'var') && isnan(Sigma_Reg)
      Sigma_Reg = [10, 10];
%  end

   RoI{1}.X2 = double(SRD.Results.X) .* pixel2nm;   % nm
   RoI{1}.Y2 = double(SRD.Results.Y) .* pixel2nm;   % nm
   RoI{1}.X2_STD = double(SRD.Results.X_STD) .* pixel2nm;   % nm
   RoI{1}.Y2_STD = double(SRD.Results.Y_STD) .* pixel2nm;   % nm

   RoI{1}.ROI = [min([RoI{1}.X1; RoI{1}.X2]), ...
                 min([RoI{1}.Y1; RoI{1}.Y2]), ...
                 max([RoI{1}.X1; RoI{1}.X2]), ...
                 max([RoI{1}.Y1; RoI{1}.Y2])];
end
save(sprintf('%s_ROIs.mat', base), 'n_ROIs', 'RoI', 'Sigma_Reg');

ROIs_pre  = cell(n_ROIs, 1);
ROIs_post = cell(n_ROIs, 1);
for i = 1 : n_ROIs
   fprintf('ROI %d\n\n', i);

   pc.ROI = [RoI{i}.ROI(1), RoI{i}.ROI(3), ...
             RoI{i}.ROI(2) - RoI{i}.ROI(1), RoI{i}.ROI(4) - RoI{i}.ROI(3)];

   X1 = RoI{i}.X1;
   Y1 = RoI{i}.Y1;
   X1_STD = RoI{i}.X1_STD;
   Y1_STD = RoI{i}.Y1_STD;

   X2 = RoI{i}.X2;
   Y2 = RoI{i}.Y2;
   X2_STD = RoI{i}.X2_STD;
   Y2_STD = RoI{i}.Y2_STD;

   XY1 = [X1, Y1];
   XY2 = [X2, Y2];

   base_file_pre  = sprintf('%s_ROI%d_pre',  basefile, i);
   base_file_post = sprintf('%s_ROI%d_post', basefile, i);
   base_file_pre1  = sprintf('%s_L1_ROI%d_pre',  basefile, i);
   base_file_pre2  = sprintf('%s_L2_ROI%d_pre',  basefile, i);
   base_file_post1 = sprintf('%s_L1_ROI%d_post', basefile, i);
   base_file_post2 = sprintf('%s_L2_ROI%d_post', basefile, i);
   base1 = sprintf('%s_L1_ROI%d', base, i);
   base2 = sprintf('%s_L2_ROI%d', base, i);

   ROIs_pre{i}.ROI = RoI{i}.ROI;
   ROIs_pre{i}.XY1 = XY1;
   ROIs_pre{i}.XY2 = XY2;

   %results_pccA = pc.pair_correlation(pixel_size, base_file_pre, XY1, XY2)
   %results_pac1A = pc.pair_correlation(pixel_size, base_file_pre1, XY1)
   %results_pac2A = pc.pair_correlation(pixel_size, base_file_pre2, XY2)
   %results_VpccA = ...
   %   pc.pair_correlation_Veatch(XY1, XY2, pixel_size, base_file_pre, 'cross');
   %results_Vpac1A = ...
   %   pc.pair_correlation_Veatch(XY1, [], pixel_size, base_file_pre1, 'auto');
   %results_Vpac2A = ...
   %   pc.pair_correlation_Veatch(XY2, [], pixel_size, base_file_pre2, 'auto');

   XY1 = [X1, Y1];  sigma1 = [X1_STD, Y1_STD];
   [XY1_SR, sigma1_SR, combined1] = SRc.clusterSR(XY1, sigma1, Sigma_Reg);
   %SRclusterFig1 = SRc.plotSRclusters();
   %SRclusterFig1.Visible = 'on';
   %saveas(SRclusterFig1, sprintf('%s_%s.fig', base1, 'SRcluster'));
   %close(SRclusterFig1);
   %SRcollapseFig1 = SRc.plotSRcollapse();
   %SRcollapseFig1.Visible = 'on';
   %saveas(SRcollapseFig1, sprintf('%s_%s.fig', base1, 'SRcollapse'));
   %close(SRcollapseFig1);
   %[results1, analysisFigs1] = SRc.analyzeSRclusters();
   %for j = 1 : length(analysisFigs1)
   %   analysisFigs1{j}.Visible = 'on';
   %   saveas(analysisFigs1{j}, sprintf('%s_%s%1d.fig', base1, 'SR', j));
   %   close(analysisFigs1{j});
   %end

   XY2 = [X2, Y2];  sigma2 = [X2_STD, Y2_STD];
   [XY2_SR, sigma2_SR, combined2] = SRc.clusterSR(XY2, sigma2, Sigma_Reg);
   %SRclusterFig2 = SRc.plotSRclusters();
   %SRclusterFig2.Visible = 'on';
   %saveas(SRclusterFig2, sprintf('%s_%s.fig', base2, 'SRcluster'));
   %close(SRclusterFig2);
   %SRcollapseFig2 = SRc.plotSRcollapse();
   %SRcollapseFig2.Visible = 'on';
   %saveas(SRcollapseFig2, sprintf('%s_%s.fig', base2, 'SRcollapse'));
   %close(SRcollapseFig2);
   %[results2, analysisFigs2] = SRc.analyzeSRclusters();
   %for j = 1 : length(analysisFigs2)
   %   analysisFigs2{j}.Visible = 'on';
   %   saveas(analysisFigs2{j}, sprintf('%s_%s%1d.fig', base2, 'SR', j));
   %   close(analysisFigs2{j});
   %end

   ROIs_post{i}.ROI = RoI{i}.ROI;
   ROIs_post{i}.XY1 = XY1_SR;
   ROIs_post{i}.XY2 = XY2_SR;

   %save(sprintf('%s_ROI%d_XYsigma.mat', base, i), ...
   %     'XY1', 'sigma1', 'XY2', 'sigma2',    ...
   %     'XY1_SR', 'sigma1_SR', 'XY2_SR', 'sigma2_SR');

   %results_pccB = pc.pair_correlation(pixel_size, base_file_post, ...
   %                                   XY1_SR, XY2_SR)
   %results_pac1B = pc.pair_correlation(pixel_size, base_file_post1, XY1_SR)
   %results_pac2B = pc.pair_correlation(pixel_size, base_file_post2, XY2_SR)
   %results_VpccB = ...
   %   pc.pair_correlation_Veatch(XY1_SR, XY2_SR, pixel_size, base_file_post,...
   %                              'cross');
   %results_Vpac1B = ...
   %   pc.pair_correlation_Veatch(XY1_SR, [], pixel_size, base_file_post1, ...
   %                              'auto');
   %results_Vpac2B = ...
   %   pc.pair_correlation_Veatch(XY2_SR, [], pixel_size, base_file_post2, ...
   %                              'auto');

   %figure();
   %hold on
   %plot(XY1_SR(:, 1), XY1_SR(:, 2), 'k.', 'MarkerSize', 10);
   %plot(XY2_SR(:, 1), XY2_SR(:, 2), 'b.', 'MarkerSize', 10);
   %title('Collapsed Two Color Plot');
   %xlabel('x (nm)');
   %ylabel('y (nm)');
   %hold off
   %print(sprintf('%s_ROI%d_collapsed.png', base, i), '-dpng');
   %close(gcf);

   %save(sprintf('%s_ROI%d_results.mat', base, i),            ...
   %     'results_pccA',  'results_pac1A',  'results_pac2A',  ...
   %     'results_VpccA', 'results_Vpac1A', 'results_Vpac2A', ...
   %     'results_pccB',  'results_pac1B',  'results_pac2B',  ...
   %     'results_VpccB', 'results_Vpac1B', 'results_Vpac2B', ...
   %     'results1', 'results2', 'c', 'pc', 'SRc');
   %save(sprintf('%s_ROI%d_results.mat', base, i), ...
   %     'results_pccA',  'results_pccB',          ...
   %     'results1', 'results2', 'c', 'pc', 'SRc');
end

base_pre  = sprintf('%s_pre',  basefile);
base_post = sprintf('%s_post', basefile);
resultsRC_pccA = ...
   pc.pair_correlation_ROIcombined(pixel_size, base_pre,  2, n_ROIs, ROIs_pre)
resultsRC_pccB = ...
   pc.pair_correlation_ROIcombined(pixel_size, base_post, 2, n_ROIs, ROIs_post)
save(sprintf('%s_results.mat', base), 'resultsRC_pccA', 'resultsRC_pccB');
